#ifndef _MOOSE_H_
#define _MOOSE_H_

#include <cstdio>
#include "../../include/cvel.h"


const VECTOR3 OFS_SEAT = _V(0,0,0.15);
const double MAX_GRAPPLING_DIST = 1.0;

//#define MAXLOAD 50
/*
typedef struct {
	double mass;
	double fuel;
	double rot;
	char name[80];
	char meshname[80];
	char plclass[80];
	bool stage;
	MESHHANDLE h_msh_pl;
	bool attached;
	VECTOR3 v;
	UINT msh_pl;
} PAYLOAD;
*/
class MOOSE: public COMMON_VESSEL_EX 
{
public:
	MOOSE (OBJHANDLE hObj, int fmodel );
	void LoadState (FILEHANDLE scn, void *vs);
	void SaveState (FILEHANDLE scn);
	void SetDefSuit();
	void SetStage ();
	void SetAnims ();
	void SetClassCaps (FILEHANDLE cfg);
	void TimeStep( double simt );
	void StrapUnstrap();
	int  ConsumeBufferedKey ( DWORD dwKey, bool fPressed, const char *keystate);
	int  ConsumeKey ( const char *keystate);
	double EXPAND_SPEED;
	double expand_proc, trans_proc;
	int numevas;
	bool Expanding, Burning, RetroDefined, defaultsuit;
	double pay_mass;
//	PAYLOAD load[MAXLOAD];

// Overloaded callback functions
	void clbkSetClassCaps (FILEHANDLE cfg);
	void clbkLoadStateEx (FILEHANDLE scn, void *vs);
	void clbkSaveState (FILEHANDLE scn);
	void clbkPostStep (double simt, double simdt, double mjd);
	int  clbkConsumeBufferedKey (DWORD key, bool down, char *kstate);
	void clbkVisualCreated (VISHANDLE vis, int refcount);
	void clbkVisualDestroyed (VISHANDLE vis, int refcount);


protected :
	PROPELLANT_HANDLE ph_main, ph_retro, ph_eject;
	THRUSTER_HANDLE th_main[3];
	THRUSTER_HANDLE retro_engine[1], eject_engine[1];
	THRUSTER_HANDLE th_hover[4];

	THGROUP_HANDLE thg_main;
	THGROUP_HANDLE thg_retro;
	THGROUP_HANDLE thg_eject;
	THGROUP_HANDLE thg_hover;
	MESHHANDLE  hCone, hChute, hChuteDeflated, hDrogue, hDefSuit, hSuit, hParaPack;
	SURFHANDLE  tex, retex;
	DOCKHANDLE dock0, dock1, dock2, dock3;
	char payloadmesh[256];
	UINT anim_expand, anim_expand2, anim_trans;
	VESSEL *depV;
	OBJHANDLE hVessel;
	bool banimsset, defaultchecked, RetroMade, PayRemoved, bExpands;
	double RetroMass, EjectMass;
	ATTACHMENTHANDLE Seatpos;
	int stage;
	double dragset;
	double RetroThrust;
	VESSELSTATUS vs;
	double drymass, xscale, yscale, zscale;

};


#endif
